<html>
<head>
<title>OgrePlatform.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePlatform.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePlatform_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Platform_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Platform_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreConfig_8h.html">OgreConfig.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 <span class="comment">/* Initial platform/compiler-related stuff to set.</span>
<a name="l00035"></a>00035 <span class="comment">*/</span>
<a name="l00036"></a><a class="code" href="OgrePlatform_8h.html#acbe1943c4784d0e38a71195b186b2648">00036</a> <span class="preprocessor">#define OGRE_PLATFORM_WIN32 1</span>
<a name="l00037"></a><a class="code" href="OgrePlatform_8h.html#ad6ca9e6d3e2b2da8d4ee9e74a8a8f437">00037</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_PLATFORM_LINUX 2</span>
<a name="l00038"></a><a class="code" href="OgrePlatform_8h.html#ac1835ebd5d472ca20f5b4b3a2ddee10a">00038</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_PLATFORM_APPLE 3</span>
<a name="l00039"></a><a class="code" href="OgrePlatform_8h.html#ab967db56cbfa2dd73046ff0aca4c6b21">00039</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_PLATFORM_SYMBIAN 4</span>
<a name="l00040"></a><a class="code" href="OgrePlatform_8h.html#a4499f0589d3e524e29fc9016a90f38d3">00040</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_PLATFORM_APPLE_IOS 5</span>
<a name="l00041"></a><a class="code" href="OgrePlatform_8h.html#a696b7f8c06236aa9ce8b16569fc13985">00041</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_PLATFORM_ANDROID 6</span>
<a name="l00042"></a><a class="code" href="OgrePlatform_8h.html#a1886da46819d5c6333981e2500f29b3c">00042</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_PLATFORM_NACL 7</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a><a class="code" href="OgrePlatform_8h.html#a6a94af2b19015f8d92898251ba51b894">00044</a> <span class="preprocessor">#define OGRE_COMPILER_MSVC 1</span>
<a name="l00045"></a><a class="code" href="OgrePlatform_8h.html#ac98b9fc56eebcda33a152960bd376375">00045</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_COMPILER_GNUC 2</span>
<a name="l00046"></a><a class="code" href="OgrePlatform_8h.html#ab912259af4a8a0d36f9b40df0d2eaa9f">00046</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_COMPILER_BORL 3</span>
<a name="l00047"></a><a class="code" href="OgrePlatform_8h.html#a9c256bb4bd2b51e471a4a22a3c735c88">00047</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_COMPILER_WINSCW 4</span>
<a name="l00048"></a><a class="code" href="OgrePlatform_8h.html#ab031cce9dea8e68007d20ebe12e4aeda">00048</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_COMPILER_GCCE 5</span>
<a name="l00049"></a><a class="code" href="OgrePlatform_8h.html#a1e1b3451f5070fe036ad603e9f3c4fa9">00049</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_COMPILER_CLANG 6</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a><a class="code" href="OgrePlatform_8h.html#a600c868168881add7117060af46eb666">00051</a> <span class="preprocessor">#define OGRE_ENDIAN_LITTLE 1</span>
<a name="l00052"></a><a class="code" href="OgrePlatform_8h.html#a077f6bc75ffd397f81a56ec2cd2838c3">00052</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_ENDIAN_BIG 2</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a><a class="code" href="OgrePlatform_8h.html#a37b62784316fecdf49524d6492b2f54e">00054</a> <span class="preprocessor">#define OGRE_ARCHITECTURE_32 1</span>
<a name="l00055"></a><a class="code" href="OgrePlatform_8h.html#a338389706b17fb84162ebfa9a4c2195a">00055</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_ARCHITECTURE_64 2</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>
<a name="l00057"></a>00057 <span class="comment">/* Finds the compiler type and version.</span>
<a name="l00058"></a>00058 <span class="comment">*/</span>
<a name="l00059"></a>00059 <span class="preprocessor">#if defined( __GCCE__ )</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMPILER OGRE_COMPILER_GCCE</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMP_VER _MSC_VER</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><span class="comment">//# include &lt;staticlibinit_gcce.h&gt; // This is a GCCE toolchain workaround needed when compiling with GCCE </span>
<a name="l00063"></a>00063 <span class="preprocessor">#elif defined( __WINSCW__ )</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMPILER OGRE_COMPILER_WINSCW</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMP_VER _MSC_VER</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor">#elif defined( _MSC_VER )</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMPILER OGRE_COMPILER_MSVC</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMP_VER _MSC_VER</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span><span class="preprocessor">#elif defined( __clang__ )</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMPILER OGRE_COMPILER_CLANG</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMP_VER (((__clang_major__)*100) + \</span>
<a name="l00072"></a>00072 <span class="preprocessor">        (__clang_minor__*10) + \</span>
<a name="l00073"></a>00073 <span class="preprocessor">        __clang_patchlevel__)</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span><span class="preprocessor">#elif defined( __GNUC__ )</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMPILER OGRE_COMPILER_GNUC</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMP_VER (((__GNUC__)*100) + \</span>
<a name="l00077"></a>00077 <span class="preprocessor">        (__GNUC_MINOR__*10) + \</span>
<a name="l00078"></a>00078 <span class="preprocessor">        __GNUC_PATCHLEVEL__)</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span><span class="preprocessor">#elif defined( __BORLANDC__ )</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMPILER OGRE_COMPILER_BORL</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_COMP_VER __BCPLUSPLUS__</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span><span class="preprocessor">#   define __FUNCTION__ __FUNC__ </span>
<a name="l00083"></a>00083 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span><span class="preprocessor">#   pragma error &quot;No known compiler. Abort! Abort!&quot;</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a>00088 <span class="comment">/* See if we can use __forceinline or if we need to use __inline instead */</span>
<a name="l00089"></a>00089 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span><span class="preprocessor">#   if OGRE_COMP_VER &gt;= 1200</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span><span class="preprocessor">#       define FORCEINLINE __forceinline</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span><span class="preprocessor">#elif defined(__MINGW32__)</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span><span class="preprocessor">#   if !defined(FORCEINLINE)</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span><span class="preprocessor">#       define FORCEINLINE __inline</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00098"></a><a class="code" href="OgrePlatform_8h.html#a724fb9f82013c782db5c3c12ea36aac8">00098</a> <span class="preprocessor"></span><span class="preprocessor">#   define FORCEINLINE __inline</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00101"></a>00101 <span class="comment">/* Finds the current platform */</span>
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="preprocessor">#if defined( __SYMBIAN32__ ) </span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_PLATFORM OGRE_PLATFORM_SYMBIAN</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">#elif defined( __WIN32__ ) || defined( _WIN32 )</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_PLATFORM OGRE_PLATFORM_WIN32</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span><span class="preprocessor">#elif defined( __APPLE_CC__)</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>    <span class="comment">// Device                                                     Simulator</span>
<a name="l00109"></a>00109     <span class="comment">// Both requiring OS version 4.0 or greater</span>
<a name="l00110"></a>00110 <span class="preprocessor">#   if __ENVIRONMENT_IPHONE_OS_VERSION_MIN_REQUIRED__ &gt;= 40000 || __IPHONE_OS_VERSION_MIN_REQUIRED &gt;= 40000</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_PLATFORM OGRE_PLATFORM_APPLE_IOS</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_PLATFORM OGRE_PLATFORM_APPLE</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span><span class="preprocessor">#elif defined(__ANDROID__)</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_PLATFORM OGRE_PLATFORM_ANDROID</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span><span class="preprocessor">#elif defined( __native_client__ ) </span>
<a name="l00118"></a>00118 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_PLATFORM OGRE_PLATFORM_NACL</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span><span class="preprocessor">#   ifndef OGRE_STATIC_LIB</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span><span class="preprocessor">#       error OGRE must be built as static for NaCl (OGRE_STATIC=true in CMake)</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span><span class="preprocessor">#   ifdef OGRE_BUILD_RENDERSYSTEM_D3D9</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span><span class="preprocessor">#       error D3D9 is not supported on NaCl (OGRE_BUILD_RENDERSYSTEM_D3D9 false in CMake)</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span><span class="preprocessor">#   ifdef OGRE_BUILD_RENDERSYSTEM_GL</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span><span class="preprocessor">#       error OpenGL is not supported on NaCl (OGRE_BUILD_RENDERSYSTEM_GL=false in CMake)</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span><span class="preprocessor">#   ifndef OGRE_BUILD_RENDERSYSTEM_GLES2</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span><span class="preprocessor">#       error GLES2 render system is required for NaCl (OGRE_BUILD_RENDERSYSTEM_GLES2=false in CMake)</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00132"></a><a class="code" href="OgrePlatform_8h.html#ad84d3cf520c16ba4ffd3715942f7f175">00132</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_PLATFORM OGRE_PLATFORM_LINUX</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>
<a name="l00135"></a>00135     <span class="comment">/* Find the arch type */</span>
<a name="l00136"></a>00136 <span class="preprocessor">#if defined(__x86_64__) || defined(_M_X64) || defined(__powerpc64__) || defined(__alpha__) || defined(__ia64__) || defined(__s390__) || defined(__s390x__)</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ARCH_TYPE OGRE_ARCHITECTURE_64</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00139"></a><a class="code" href="OgrePlatform_8h.html#a4de9497f1c50d8052061e4870d5cdb42">00139</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ARCH_TYPE OGRE_ARCHITECTURE_32</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142 <span class="comment">// For generating compiler warnings - should work on any compiler</span>
<a name="l00143"></a>00143 <span class="comment">// As a side note, if you start your message with &#39;Warning: &#39;, the MSVC</span>
<a name="l00144"></a>00144 <span class="comment">// IDE actually does catch a warning :)</span>
<a name="l00145"></a><a class="code" href="OgrePlatform_8h.html#a9201035492049999bc82d4baa25ee090">00145</a> <span class="preprocessor">#define OGRE_QUOTE_INPLACE(x) # x</span>
<a name="l00146"></a><a class="code" href="OgrePlatform_8h.html#ab79b68443593aa3abe67d6adea621226">00146</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_QUOTE(x) OGRE_QUOTE_INPLACE(x)</span>
<a name="l00147"></a><a class="code" href="OgrePlatform_8h.html#ab61ba9272b27cdd1181dd5a18d40b750">00147</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_WARN( x )  message( __FILE__ &quot;(&quot; QUOTE( __LINE__ ) &quot;) : &quot; x &quot;\n&quot; )</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>
<a name="l00149"></a>00149 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00150"></a>00150 <span class="comment">// Windows Settings</span>
<a name="l00151"></a>00151 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
<a name="l00153"></a>00153 <span class="comment">// If we&#39;re not including this from a client build, specify that the stuff</span>
<a name="l00154"></a>00154 <span class="comment">// should get exported. Otherwise, import it.</span>
<a name="l00155"></a>00155 <span class="preprocessor">#   if defined( OGRE_STATIC_LIB )</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>        <span class="comment">// Linux compilers don&#39;t have symbol import/export directives.</span>
<a name="l00157"></a>00157 <span class="preprocessor">#       define _OgreExport</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span><span class="preprocessor">#       define _OgrePrivate</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span><span class="preprocessor">#       if defined( OGRE_NONCLIENT_BUILD )</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span><span class="preprocessor">#           define _OgreExport __declspec( dllexport )</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span><span class="preprocessor">#       else</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span><span class="preprocessor">#           if defined( __MINGW32__ )</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span><span class="preprocessor">#               define _OgreExport</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span><span class="preprocessor">#           else</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span><span class="preprocessor">#               define _OgreExport __declspec( dllimport )</span>
<a name="l00167"></a>00167 <span class="preprocessor"></span><span class="preprocessor">#           endif</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span><span class="preprocessor">#       define _OgrePrivate</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00171"></a>00171 <span class="preprocessor"></span><span class="comment">// Win32 compilers use _DEBUG for specifying debug builds.</span>
<a name="l00172"></a>00172 <span class="comment">// for MinGW, we set DEBUG</span>
<a name="l00173"></a>00173 <span class="preprocessor">#   if defined(_DEBUG) || defined(DEBUG)</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_DEBUG_MODE 1</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_DEBUG_MODE 0</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179 <span class="comment">// Disable unicode support on MingW for GCC 3, poorly supported in stdlibc++</span>
<a name="l00180"></a>00180 <span class="comment">// STLPORT fixes this though so allow if found</span>
<a name="l00181"></a>00181 <span class="comment">// MinGW C++ Toolkit supports unicode and sets the define __MINGW32_TOOLBOX_UNICODE__ in _mingw.h</span>
<a name="l00182"></a>00182 <span class="comment">// GCC 4 is also fine</span>
<a name="l00183"></a>00183 <span class="preprocessor">#if defined(__MINGW32__)</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span><span class="preprocessor"># if OGRE_COMP_VER &lt; 400</span>
<a name="l00185"></a>00185 <span class="preprocessor"></span><span class="preprocessor">#  if !defined(_STLPORT_VERSION)</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span><span class="preprocessor">#   include&lt;_mingw.h&gt;</span>
<a name="l00187"></a>00187 <span class="preprocessor">#   if defined(__MINGW32_TOOLBOX_UNICODE__) || OGRE_COMP_VER &gt; 345</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span><span class="preprocessor">#    define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span><span class="preprocessor">#    define OGRE_UNICODE_SUPPORT 0</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span><span class="preprocessor">#  else</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00194"></a>00194 <span class="preprocessor"></span><span class="preprocessor">#  endif</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span><span class="preprocessor"># else</span>
<a name="l00196"></a>00196 <span class="preprocessor"></span><span class="preprocessor">#  define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span><span class="preprocessor"># endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span><span class="preprocessor">#  define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>
<a name="l00202"></a>00202 <span class="preprocessor">#endif // OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>
<a name="l00204"></a>00204 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00205"></a>00205 <span class="comment">// Symbian Settings</span>
<a name="l00206"></a>00206 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_SYMBIAN</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span><span class="preprocessor">#   define _OgreExport </span>
<a name="l00208"></a>00208 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_DEBUG_MODE 0</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span><span class="preprocessor">#   define _OgrePrivate</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span><span class="preprocessor">#     define CLOCKS_PER_SEC  1000</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span><span class="comment">//  pragma def were found here: http://www.inf.pucrs.br/~eduardob/disciplinas/SistEmbarcados/Mobile/Nokia/Tools/Carbide_vs/WINSCW/Help/PDF/C_Compilers_Reference_3.2.pdf</span>
<a name="l00213"></a>00213 <span class="preprocessor">#     pragma warn_unusedarg off</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span><span class="preprocessor">#     pragma warn_emptydecl off</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span><span class="preprocessor">#     pragma warn_possunwant off</span>
<a name="l00216"></a>00216 <span class="preprocessor"></span><span class="comment">// A quick define to overcome different names for the same function</span>
<a name="l00217"></a>00217 <span class="preprocessor">#   define stricmp strcasecmp</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span><span class="preprocessor">#   ifdef DEBUG</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_DEBUG_MODE 1</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_DEBUG_MODE 0</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span><span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00225"></a>00225 <span class="comment">// Android Settings</span>
<a name="l00226"></a>00226 <span class="comment">/*</span>
<a name="l00227"></a>00227 <span class="comment">#if OGRE_PLATFORM == OGRE_PLATFORM_ANDROID</span>
<a name="l00228"></a>00228 <span class="comment">#   define _OgreExport </span>
<a name="l00229"></a>00229 <span class="comment">#   define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00230"></a>00230 <span class="comment">#   define OGRE_DEBUG_MODE 0</span>
<a name="l00231"></a>00231 <span class="comment">#   define _OgrePrivate</span>
<a name="l00232"></a>00232 <span class="comment">#     define CLOCKS_PER_SEC  1000</span>
<a name="l00233"></a>00233 <span class="comment">//  pragma def were found here: http://www.inf.pucrs.br/~eduardob/disciplinas/SistEmbarcados/Mobile/Nokia/Tools/Carbide_vs/WINSCW/Help/PDF/C_Compilers_Reference_3.2.pdf</span>
<a name="l00234"></a>00234 <span class="comment">#     pragma warn_unusedarg off</span>
<a name="l00235"></a>00235 <span class="comment">#     pragma warn_emptydecl off</span>
<a name="l00236"></a>00236 <span class="comment">#     pragma warn_possunwant off</span>
<a name="l00237"></a>00237 <span class="comment">// A quick define to overcome different names for the same function</span>
<a name="l00238"></a>00238 <span class="comment">#   define stricmp strcasecmp</span>
<a name="l00239"></a>00239 <span class="comment">#   ifdef DEBUG</span>
<a name="l00240"></a>00240 <span class="comment">#       define OGRE_DEBUG_MODE 1</span>
<a name="l00241"></a>00241 <span class="comment">#   else</span>
<a name="l00242"></a>00242 <span class="comment">#       define OGRE_DEBUG_MODE 0</span>
<a name="l00243"></a>00243 <span class="comment">#   endif</span>
<a name="l00244"></a>00244 <span class="comment">#endif</span>
<a name="l00245"></a>00245 <span class="comment">*/</span>
<a name="l00246"></a>00246 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00247"></a>00247 <span class="comment">// Linux/Apple/iOs/Android/Symbian/NaCl Settings</span>
<a name="l00248"></a>00248 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_LINUX || OGRE_PLATFORM == OGRE_PLATFORM_APPLE || OGRE_PLATFORM == OGRE_PLATFORM_APPLE_IOS || \</span>
<a name="l00249"></a>00249 <span class="preprocessor">    OGRE_PLATFORM == OGRE_PLATFORM_ANDROID || OGRE_PLATFORM == OGRE_PLATFORM_NACL</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>
<a name="l00251"></a>00251 <span class="comment">// Enable GCC symbol visibility</span>
<a name="l00252"></a>00252 <span class="preprocessor">#   if defined( OGRE_GCC_VISIBILITY )</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span><span class="preprocessor">#       define _OgreExport  __attribute__ ((visibility(&quot;default&quot;)))</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span><span class="preprocessor">#       define _OgrePrivate __attribute__ ((visibility(&quot;hidden&quot;)))</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00256"></a><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">00256</a> <span class="preprocessor"></span><span class="preprocessor">#       define _OgreExport</span>
<a name="l00257"></a><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">00257</a> <span class="preprocessor"></span><span class="preprocessor">#       define _OgrePrivate</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>
<a name="l00260"></a>00260 <span class="comment">// A quick define to overcome different names for the same function</span>
<a name="l00261"></a><a class="code" href="OgrePlatform_8h.html#a4e0be90a3757e352f42612d09a7d1aa5">00261</a> <span class="preprocessor">#   define stricmp strcasecmp</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>
<a name="l00263"></a>00263 <span class="preprocessor">#   ifdef DEBUG</span>
<a name="l00264"></a>00264 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_DEBUG_MODE 1</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00266"></a><a class="code" href="OgrePlatform_8h.html#a15ea2b61c3e8ac05db2972f528f94753">00266</a> <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_DEBUG_MODE 0</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00268"></a>00268 <span class="preprocessor"></span>
<a name="l00269"></a>00269 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_PLATFORM_LIB &quot;OgrePlatform.bundle&quot;</span>
<a name="l00271"></a>00271 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE_IOS</span>
<a name="l00272"></a>00272 <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_PLATFORM_LIB &quot;OgrePlatform.a&quot;</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span><span class="preprocessor">#else //OGRE_PLATFORM_LINUX</span>
<a name="l00274"></a><a class="code" href="OgrePlatform_8h.html#abd45db57e45902634b2b9dbb7b2b9338">00274</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_PLATFORM_LIB &quot;libOgrePlatform.so&quot;</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>
<a name="l00277"></a>00277 <span class="comment">// Always enable unicode support for the moment</span>
<a name="l00278"></a>00278 <span class="comment">// Perhaps disable in old versions of gcc if necessary</span>
<a name="l00279"></a><a class="code" href="OgrePlatform_8h.html#a6b22414ce99a335fea0f51584cb766e4">00279</a> <span class="preprocessor">#define OGRE_UNICODE_SUPPORT 1</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>
<a name="l00281"></a>00281 <span class="preprocessor">#endif</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>
<a name="l00283"></a>00283 <span class="comment">//----------------------------------------------------------------------------</span>
<a name="l00284"></a>00284 <span class="comment">// Endian Settings</span>
<a name="l00285"></a>00285 <span class="comment">// check for BIG_ENDIAN config flag, set OGRE_ENDIAN correctly</span>
<a name="l00286"></a>00286 <span class="preprocessor">#ifdef OGRE_CONFIG_BIG_ENDIAN</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span><span class="preprocessor">#    define OGRE_ENDIAN OGRE_ENDIAN_BIG</span>
<a name="l00288"></a>00288 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00289"></a><a class="code" href="OgrePlatform_8h.html#a9af9f9208025e8051717aee67e4e7267">00289</a> <span class="preprocessor"></span><span class="preprocessor">#    define OGRE_ENDIAN OGRE_ENDIAN_LITTLE</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span>
<a name="l00292"></a>00292 <span class="comment">// Integer formats of fixed bit width</span>
<a name="l00293"></a><a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">00293</a> <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>;
<a name="l00294"></a><a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">00294</a> <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>;
<a name="l00295"></a><a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">00295</a> <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>;
<a name="l00296"></a><a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">00296</a> <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a>;
<a name="l00297"></a><a class="code" href="namespaceOgre.html#a5c8843f6e8086a9239fed14de8b9d859">00297</a> <span class="keyword">typedef</span> <span class="keywordtype">short</span> <a class="code" href="namespaceOgre.html#a5c8843f6e8086a9239fed14de8b9d859">int16</a>;
<a name="l00298"></a><a class="code" href="namespaceOgre.html#aa258bf39b19d5814a79d6533763e02ba">00298</a> <span class="keyword">typedef</span> <span class="keywordtype">char</span> <a class="code" href="namespaceOgre.html#aa258bf39b19d5814a79d6533763e02ba">int8</a>;
<a name="l00299"></a>00299 <span class="comment">// define uint64 type</span>
<a name="l00300"></a>00300 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>    <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> __int64 <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>;
<a name="l00302"></a>00302     <span class="keyword">typedef</span> __int64 <a class="code" href="namespaceOgre.html#a44bca44dae060c979d0e74cbf77cf4dc">int64</a>;
<a name="l00303"></a>00303 <span class="preprocessor">#else</span>
<a name="l00304"></a><a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">00304</a> <span class="preprocessor"></span>    <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <a class="code" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>;
<a name="l00305"></a><a class="code" href="namespaceOgre.html#a44bca44dae060c979d0e74cbf77cf4dc">00305</a>     <span class="keyword">typedef</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <a class="code" href="namespaceOgre.html#a44bca44dae060c979d0e74cbf77cf4dc">int64</a>;
<a name="l00306"></a>00306 <span class="preprocessor">#endif</span>
<a name="l00307"></a>00307 <span class="preprocessor"></span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
